class DocumentTemplate
	@@templates	= {}
	def DocumentTemplate.add_template( key, template )
		@@templates[key] = template.gsub(/^\t*/, '')	#fixme check uniqi
	end
	def DocumentTemplate.[]( key )
		if @@templates[key]
			return @@templates[key].dup
		else
			puts "Template unknown: #{key}"
			return nil
		end
	end
	def DocumentTemplate.keys()
		return @@templates.keys
	end
end


DocumentTemplate.add_template( 
	:include, %q|<<prefix>>
		% ----------------------------------------------------------------
		<<head>>
		% ----------------------------------------------------------------
		<<body>>
		% ----------------------------------------------------------------
	|)
	
DocumentTemplate.add_template( 
	:article, %q|<<prefix>>
		\documentclass[<<classoptions>>]{scrartcl}
		\usepackage{babel}
		\usepackage[ansinew]{inputenc}
		\usepackage{hyperref}
		% ----------------------------------------------------------------
		<<head>>
		% ----------------------------------------------------------------
		\begin{document}
		<<body>>
		\end{document}
		% ----------------------------------------------------------------
	|)
DocumentTemplate.add_template( 
	:festodoc, %q|<<prefix>>
		\documentclass[<<classoptions>>,lke]{festodoc}
		%\usepackage{changes}
		% ----------------------------------------------------------------
		<<head>>
		% ----------------------------------------------------------------
		\begin{document}
		<<body>>
		\end{document}
		% ----------------------------------------------------------------
	|)
#~ DocumentTemplate.add_template( 
	#~ :report, '',
	#~ |)
#~ DocumentTemplate.add_template( 
	#~ :book, '',
	#~ |)
DocumentTemplate.add_template( 
	:html, %q|<!--
		<<prefix>>
		-->
		<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
		<html>
		<<head>>
		<<body>>
		</html>
		|)


