#Create a test-document with DocGenerator.rb.
#
#This program loads DocGenerator.rb and 
#use most of the features of the tool.
#
#Start the tool and two documents
#-	test.html and
#-	test.tex
#are created. 
require 'DocGenerator'

##############
## Test
##############
puts '='*40
#~ puts Element.overview( [Element.get(:h1)] )
#~ puts Element.overview( [Title] )
#~ puts Element.overview( )
#~ puts '='*40

puts ">Create a test-document"
doc = Document.new()

doc.head	<< element( :usepackage, { }, 'longtable' )
#~ doc.head	<< element( :usepackage, { :option => [] }, 'longtable' )
doc.head	<< element( :sepline )	#Separator line


#~ doc.head	<< element(:title, {}, 'Titel')
#~ doc.head	<< element(:author, {}, 'Authorname')
doc.title	='Titel'
doc.author	= 'Authorname'
doc.date	= 'Datum'
doc.keywords	= 'Test, DocGenerator.rb'
doc.description	= 'Testdokument fr DocGenerator.rb'

doc.head	<< element(:meta, {:name => 'xxx', :content => 'inhalt' } )
#~ puts '!And at 'save' an error: Meta-Tag without required attributes'
#~ doc.head	<< element(:meta, {} )


doc.body	<< element(:maketitle)
doc.body[:lang] << 'de'

# ###############################
doc.body	<< element(:h1, {}, 'Listen')

doc.body	<< element(:h2, {}, 'Unnummerierte Liste')
doc.body	<< ul = element(:ul)
ul		<< element( :li, {}, 'Listitem 1' )
ul		<< element( :li, {}, 'Listitem 2' )
ul		<< element( :li, {}, 'Listitem 3' )

doc.body	<< element(:h2, {}, 'Nummerierte Liste')
doc.body	<< ol = element(:ol)
ol		<< element( :li, {}, 'Listitem 1' )
ol		<< element( :li, {}, 'Listitem 2' )
ol		<< element( :li, {}, 'Listitem 3' )

# ###############################
doc.body	<< element(:h1, {}, 'Absatzsteuerung')
doc.body	<< 'Text'
doc.body	<< element( :br )
doc.body	<< 'Text'
puts '!And now an error: Content added to makro without content'
doc.body	<< element( :br, {}, 'Text in br' )

# ###############################
doc.body	<< element(:h1, {}, 'Links und Verweise')
doc.body	<< element(:a,	{ :href => 'http://www.lickert.net/scripting' }, 'Link zu meinen Skripten').cr
doc.body	<< element(:url,{}, 'http://www.lickert.net/scripting')


# ###############################
doc.body	<< element(:h1, {}, 'Relatives einfgen')
doc.body	<< par = element(:par, {}, 'Absatz')

doc.body.insertbefore( par, 'Einschub vor dem Absatz' )
doc.body.insertafter( par, 'Einschub nach dem Absatz' )

puts "!And now an error: insertbefore with a non-existing target"
doc.body.insertbefore( 'a', 'Before List' )


# ###############################
Element.log( true )
doc.body	<< element(:h1, {}, 'Tabellen')
columnnumber = 5
doc.body	<< tab = element(:tabular, {
				:columns => columnnumber,
				:columndescription =>	'c' * columnnumber
			} ).CR

tab 	<< row = element( :row, {:add_vspace=>'1ex'}  ).cr
row	<< element(:multicolumn, {
			:columns	=> columnnumber,
			:pos		=> 'c',
		}, 'Titel' )
row.hline

'a'.upto('f'){|num|
	tab 		<< row = element( :row ).cr
	1.upto(columnnumber){|letter|
		row		<< element(:column, {}, "#{num}#{letter}" )
	}
}



# ###############################
doc.body	<< element(:h1, {}, 'Ende')

# ###############################
puts ">Save the files"
doc.save( 'test.html',	true )
if doc.save( 'test.tex',	true )
	#Translate immediate to dvi
	require 'C:/usr/Script/MyScripts' if File.exist?('C:/usr/Script/MyScripts.rb')
	require 'rtex'
	tex = Chain.new()
	tex.file= 'test.tex'
	tex.latex()
	tex.execute
end

