#
#Definition of HTML-Tags (Sublasses of Element).
#

#~ require 'cgi'

HTML_ATTR_CORE	= {	:id=>nil, :class => nil, :style=>nil, :title => nil }
HTML_ATTR_I18N	= {	:lang	=> ['en', 'de'] ,
					:dir	=> ['ltr', 'rtl']
				}
HTML_ATTR_EVENTS = {	:onclick => nil, :ondblclick =>nil, 
					:onmousedown => nil, :onmouseup => nil, :onmouseover => nil, :onmousemove => nil, :onmouseout => nil, 
					:onkeypress =>nil, :onkeyup =>nil, :onkeydown =>nil
			}
HTML_ATTR_ALL = {}
HTML_ATTR_ALL.update(HTML_ATTR_I18N)
HTML_ATTR_ALL.update(HTML_ATTR_EVENTS)
HTML_ATTR_ALL.update(HTML_ATTR_CORE)

HTML_ATTR_ALIGN = ['left', 'center', 'right', 'justify', 'char']
HTML_ATTR_VALIGN = ['bottom', 'top', 'middle', 'baseline']

require 'DocGenerator' if __FILE__ == $0

Element.create( [:h1],	HTML_ATTR_ALL,	true, 
	{	:htmltag	=> 'h1',
		:latex	=> "\n" + '\section{#{@content}}' + "\n"
	} )
Element.create( [:h2],	HTML_ATTR_ALL,	true, 
	{	:htmltag	=> 'h2',
		:latex	=> "\n" + '\section{#{@content}}' + "\n"
	} )
Element.create( [:br, 'br/', 'br'], {},false, 
	{	:htmltag => 'br',
		:latex	=> "\n" + '\newline' + "\n"
	} )
Element.create( [:ul],	HTML_ATTR_ALL,	true, 
	{	:htmltag => 'ul',
		:latex	=>	"\n" + '\begin{itemize}' + 
					'#{@content}' + "\n" +
					"\n" + '\end{itemize}'
	} )
Element.create( [:li],		HTML_ATTR_ALL,	true, 
	{	:htmltag => 'li',
		:latex	=> "\n" + '\item #{@content}' + "\n"
	} )

#~ class Tag < Element
	#~ #Generall attributes:

	#~ hattr  = all.update({:align => align}) #attr for h1..h6

	#~ #List of all supported tags with their attributes.
	#~ #fixme:
	#~ #-Standard-attributes (cgi?)
	#~ #-complete values
	#~ @@tags	= {
		#~ :htmltag	=> {},	#complete it
		#~ :head	=> {},	#complete it
		#~ :meta=> { :content=>nil, :name=>nil }, #complete it
		#~ :body=> core.update({}),	#complete it
		#~ :a	=> all.update({:href	=> nil, :alt=>nil, :longdesc=>nil, :value=>nil, :shape=>nil, :coords=>nil}), #complete it
		#~ :title	=> {}, #complete it
		#~ :br	=> {:clear=>['all']},	#complete it
		#~ :hr	=> {}, #complete it
		#~ :span=> all.update({}),	#complete it
		#~ :table=> {:border=>nil, :width=>nil, :cellpadding=>nil, :cellspacing=>nil},#complete it
		#~ :colgroup => {}, #comlpete it
		#~ :col	=> {:width=>nil},
		#~ :tr	=> {:align=>align},#complete it
		#~ :th	=> {:colspan => nil, :rowspan => nil, :align=>align, :valign=>valign, :border=>nil, :width=>nil},#complete it
		#~ :td	=> nil,	#like :th
		#~ :p	=> all.update({}),#complete it
		#~ :'p/'	=> all.update({}),#complete it
		#~ :img	=> all.update({:width=>nil, :src=>nil,:alt=>nil, :longdesc=>nil, :border=>nil,:name=>nil, :align=>[:top,:middle,:bottom,:left,:right], :hspace=>nil, :vspace => nil, :usemap=>nil}),#complete it
		#~ :ul	=> {}, #complete it
		#~ :ol	=> {}, #complete it
		#~ :li	=> {}, #complete it
		#~ :"li/"	=> {}, #complete it
		#~ :div	=> core.update({}), #complete it
		#~ :h1	=> hattr,
		#~ :h2	=> hattr,
		#~ :h3	=> hattr,
		#~ :h4	=> hattr,
		#~ :h5	=> hattr,
		#~ :h6	=> hattr,
		#~ :nobr	=> {}, #complete it
		#~ :link	=> {}, #complete it
		#~ :em	=> {}, #complete it
		#~ :strong	=> {}, #complete it
		#~ :center	=> {}, #complete it
		#~ :map	=> all.update({}), #complete it
		#~ :area	=> all.update({}), #complete it
		#~ :option=> {:value=>nil}, #complete it
		#~ :select=> events.update({}), #complete it
		#~ :sub	=> all.update({}), #complete it
		#~ :sup	=> all.update({}), #complete it
		#~ :pre	=> {}, #complete it
		#~ :code	=> {}, #complete it
	#~ }
	#~ @@tags_without_content = [ :br, :hr, :img, :meta, :link, :li2, :'p/' ]
	#~ @@tags[:td] = @@tags[:th]
	#~ @@tags[:"p/"] = @@tags[:p]
	#~ @@tags[:"img/"] = @@tags[:img]
	#~ @@tags[:"br/"] = @@tags[:br]
	#~ @@tags[:"hr/"] = @@tags[:hr]
	#~ @@tags[:"meta/"] = @@tags[:meta]
	#~ @@tags[:"link/"] = @@tags[:link]
	#~ #puts @@tags[:tr][:align]
	
	#~ #Function to create a HTML-File. Return the html, head and body to be filled.
	#~ #An optional title is possible.
	#~ #
	#~ #Fixme:  '<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">'
	#~ def Tag.create_html( par = {} )
		#~ #
		#~ par = {:title => par } if par.is_a?(String)
		#~ #
		#~ html = Tag(:htmltag).CR
		#~ html << head = Tag(:head).CR
		#~ html << body = Tag(:body).CR
		
		#~ par.each{|key, value|
			#~ case key
			#~ when :title
				#~ head << Tag(:title, {}, par[:title] ).CR
				#~ body << Tag(:h1,{},par[:title]).CR
			#~ when :keywords, :description
				#~ #fixme complete
				#~ head << Tag(:meta, { :name=>key.to_s, :content => value } ).cr
			#~ when :language
				#~ html.attr["lang"] = value
			#~ else
				#~ body << Tag(:meta, { :name=>key.to_s, :content => value } ).CR
			#~ end
		#~ }
		#~ return html, head, body
	#~ end
	#~ #Return a valid doctype. (needed, if a Tag html is saved).
	#~ def Tag.doctype()
		#~ return '<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">'
	#~ end
	#~ def Tag.save( tag, filename)
		#~ if ! ( tag.tagname =~ /html/i )
			#~ raise "Tag: Save only possible for html-tag"
		#~ end
		#~ f = File.new( filename, 'w' )
		#~ f << Tag.doctype
		#~ #f << tag
		#~ f << CGI.pretty(tag.to_s)
		#~ f.close
	#~ end
	
	#~ #Create the Tag with its content
	#~ def to_s
		#~ tag = "<" << @tagname + @attr.sort.collect{|name, value|
				#~ if value==true
					#~ ' ' << name
				#~ else
					#~ ' ' << name << '="' << CGI::escapeHTML(value) << '"' if value
				#~ end
			#~ }.to_s 
		#~ if @endtag
			#~ tag	<< '>' << @item.to_s << '</' << @tagname << '>'
		#~ else
			#~ tag	<< ' />' << @item.to_s 
		#~ end
		#~ tag = "\n" + tag + "\n" if @cr
		#~ return tag
	#~ end
#~ end	#Tag

#Create a Tag directly without a new. 
#This feature allows also the usage of a block.
#
#Usage:
#	Tag(tagname [, attr [, item]])
#	Tag(tagname [, attr [, item]]) {...}
#-	tagname: The Tag. Can be a string or an symbol.
#	If it is a symbol, the symbol is checked.
#-	attr: A Hash, containing all attributes.
#-	item: (list) of the content of the Tag. Can be defined also in th block.
#Example:
#	Tag('a', {'href'=> 'url'} )
#	Tag('a', {'href'=> 'url'}, 'content' )
#	Tag('a', {'href'=> 'url'} ){'content' }
#	Tag('a', {'href'=> 'url'}, ['x'] ){'content' }
#returns:
#	<a href="url"></a>
#	<a href="url">content</a>
#	<a href="url">content</a>
#	<a href="url">xcontent</a>
#
#If a tag without content is required (e.g. img has only attributes, or br)
#the tagname must contain a '/' in the end.
#Example:
#	Tag('br/')
def Tag(tagname,attr = {},item=[])
	return element(tagname,attr,item)
	if iterator?
		obj << yield
	end
	obj
end
