#
#Definition of elements for class DocGenerator_scrlettr2.rb
#used by for DocGenerator.rb
#
if __FILE__ == $0
	require 'DocGenerator' 
end

DocumentTemplate.add_template( 
	:scrlttr2, %q|<<prefix>>
		\documentclass[<<classoptions>>]{scrlttr2}
		\usepackage{babel}
		\usepackage[ansinew]{inputenc}
		\usepackage{hyperref}
		% ----------------------------------------------------------------
		<<head>>
		% ----------------------------------------------------------------
		\begin{document}
		<<body>>
		\end{document}
		% ----------------------------------------------------------------
	|)


class Letter < Environment
	Element.add( [:letter],  self )
	add_attributes( 		{
			:address => Attribute.create( [ :latex, :obligatory ] ),
			:opening => Attribute.create( [ :latex, :obligatory ] ),
		}
	) 
	def to_latex_environment( environment)
		cmd	=	''
		cmd	<<	"\n" if @crbefore
		cmd	<<	"\n\\begin{#{environment}}"
		cmd	<< "{#{@attr[:address]}}\n"
		cmd	<< "\\opening{#{@attr[:opening]}}\n"
		cmd	<< @content.to_s
		cmd	= cmd.chomp + "\n"
		cmd	<<	"\\end{#{environment}}\n"
		cmd	<<	"\n" if @crafter
		return cmd
	end
	def to_latex( )
		return to_latex_environment( 'letter' )
	end
end